cordova.define("com.egbox.plugin.egboxSdkFor3rd.egboxSdkFor3rd", function(require, exports, module) {
var exec = require('cordova/exec');

exports.get3rdRequestBy3rdApp = function (callback) {
    return exec(function(requestJson){
        //android直接拿到的是一个完整结构的json字符串
        //ios下拿到的是一个 schemeUrl://base64Data 形式的字符串, 这里主动将data提取出来并解码
        var data = requestJson;
        if(isIOS()&&null!=requestJson){
            var base64Data = requestJson.split("://")[1];
            //decodeURIComponent处理中文
            var base64 = new Base64();
            data = base64.decode(base64Data);
        }
        return callback(null,data);
    }, function(err){
        return callback(null!=err?err:'unknow error');
    }, 'egboxSdkFor3rd', 'get3rdRequestBy3rdApp', []);
};
exports.endWith3rdResultBy3rdApp = function (resultJson, schemeUrl, callback) {
    //android直接将json字符串作为参数传递, 无需传递url参数
    //ios需将json字符串进行base64编码再和url拼接传入
    var data = resultJson;
    if(isIOS()){
        //encodeURIComponent处理中文
        var base64 = new Base64();
        data = schemeUrl+base64.encode(resultJson);
    }
	return exec(function(rst){
        return callback(null,rst);
    }, function(err) {
        return callback(null!=err?err:'unknow error');
    }, "egboxSdkFor3rd", "endWith3rdResultBy3rdApp", [data]);
};
//根据url启动app,特地在这里实现,网上给的插件不靠谱
exports.launchAppForIOS = function (schemeUrl, callback) {
	return exec(function(rst){
        return callback(null,rst);
    }, function(err) {
        console.error("launchAppForIOS error:"+err);
        return callback(null,false);
    }, "egboxSdkFor3rd", "launchAppForIOS", [schemeUrl]);
};


//临时判断系统类型的代码
var curDevicePlatform = null;
function getDevicePlatform() {
    //第一次获取
    if(null == curDevicePlatform){
        if (/(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent)) {
            curDevicePlatform = 'ios';
        } else if (/(Android)/i.test(navigator.userAgent)) {
            curDevicePlatform = 'android';
        } else if(/(Windows)/i.test(navigator.userAgent)) {
            curDevicePlatform = 'windows';
        } else if(/(Linux)/i.test(navigator.userAgent)) {
            curDevicePlatform = 'linux';
        } else {
            //TODO: windows or linux
            curDevicePlatform = 'unknow';
        }
    }
    return curDevicePlatform;
}
function isIOS(){
    return 'ios' == getDevicePlatform();
}
function isAndroid(){
    return 'android' == getDevicePlatform();
}


//base64编码
function Base64() {
 
    // private property
    _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
 
    // public method for encoding
    this.encode = function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = _utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
            _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
            _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
    }
 
    // public method for decoding
    this.decode = function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
    }
 
    // private method for UTF-8 encoding
    _utf8_encode = function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
 
        }
        return utftext;
    }
 
    // private method for UTF-8 decoding
    _utf8_decode = function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
        while ( i < utftext.length ) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }
}
});
